# coding: utf-8

"""
    Orbital transfer API

    Orbital transfer API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from orbital_transfer.models.frame import Frame
from orbital_transfer.models.time_stamped_pv_coordinates import TimeStampedPVCoordinates
from typing import Optional, Set
from typing_extensions import Self

class OrbitOrekitParameters(BaseModel):
    """
    OrbitOrekitParameters
    """ # noqa: E501
    type: Optional[StrictStr] = None
    frame: Optional[Frame] = None
    var_date: Optional[StrictStr] = Field(default=None, alias="date")
    mu: Optional[Union[StrictFloat, StrictInt]] = None
    pv_coordinates: Optional[TimeStampedPVCoordinates] = Field(default=None, alias="pvCoordinates")
    __properties: ClassVar[List[str]] = ["type", "frame", "date", "mu", "pvCoordinates"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['CARTESIAN', 'CIRCULAR', 'EQUINOCTIAL', 'KEPLERIAN']):
            raise ValueError("must be one of enum values ('CARTESIAN', 'CIRCULAR', 'EQUINOCTIAL', 'KEPLERIAN')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrbitOrekitParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of frame
        if self.frame:
            _dict['frame'] = self.frame.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pv_coordinates
        if self.pv_coordinates:
            _dict['pvCoordinates'] = self.pv_coordinates.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrbitOrekitParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "frame": Frame.from_dict(obj["frame"]) if obj.get("frame") is not None else None,
            "date": obj.get("date"),
            "mu": obj.get("mu"),
            "pvCoordinates": TimeStampedPVCoordinates.from_dict(obj["pvCoordinates"]) if obj.get("pvCoordinates") is not None else None
        })
        return _obj


